#ifndef _EQDRAW_H_
#define _EQDRAW_H_

#include <map>
#include <iostream>
#include <vector>

#include "drawing.h"

template<class indep, class dep>
class fct {
public:
  virtual dep operator()(indep) const=0;
};

extern double calculation_step; //relative to width
extern double visualization_step;
extern double spatial_grid;
extern double clipping_distance; //relative to spatial_grid

map<double,double>
DiffSolve(const fct<point,double> &f,point start, drawer &draw);

int DiffDrawAll(const fct<point,double> &f, drawer &draw);
int FnDraw(const fct<double,double> &f,drawer &draw);
int CurveDraw(const fct<double,point> &f,drawer &draw, 
	      double t0, double t1);

void AxesDraw(drawer &draw);

#endif
